from dataclasses import dataclass
from typing import Mapping, Sequence, Set


@dataclass
class StringAnnotation:
    type: str
    start: int
    end: int
    feature_properties: Mapping[str, Set[str]]
    
@dataclass
class AnnotatedString:
    name: str
    sequence: str
    annotations: Sequence[StringAnnotation]

def get_feature_coding(annotated_string: AnnotatedString, string_annotation: StringAnnotation) -> str:
    return annotated_string.sequence[string_annotation.start:string_annotation.end]